package com.chaitin.proxy;


import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Proxy;

public class ProxyTest {
    public static void main(String[] args) {
        IUser user = new UserImpl();

        // 静态代理
        IUser userProxy = new UserProxy(user);
        userProxy.login();
        // 动态代理 不需要创建单独的代理类 但是仍然需要创建调用处理器类
        InvocationHandler userInvocationHandler = new UserInvocationHandler(user);
        // 要代理的接口，要做的事情（调用处理器），类加载器
        // 默认会返回一个Object对象，我们需要将其转为IUser
        IUser userDynamicProxy = (IUser) Proxy.newProxyInstance(user.getClass().getClassLoader(), user.getClass().getInterfaces(), userInvocationHandler);
        // 一旦调用动态代理，那么就自动执行invoke方法
        userDynamicProxy.login();
    }
}
