package com.chaitin.proxy;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.Date;

public class UserInvocationHandler implements InvocationHandler {
    IUser user;
    private final static Logger logger = LoggerFactory.getLogger(UserInvocationHandler.class);
    public UserInvocationHandler(IUser user){
        this.user = user;
    }
    //反射调用，java底层实现，在外头写里面就能知道调用了啥,完了对着代理的对象调用捕获的方法
    @Override
    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
        method.invoke(user, args);
        logger.info("日志动态代理登录记录");
        return null;
    }
}
