package com.chaitin.proxy;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.text.SimpleDateFormat;
import java.util.Date;

public class UserProxy implements IUser{
    IUser user;
    private static final Logger logger = LoggerFactory.getLogger(UserProxy.class);
    public UserProxy (IUser user){
        this.user = user;
    }

    /**
     *  静态代理的问题在于如果接口声明的方法很多那么要一个个去写实现
     *  代理类里面是不知道外面调用了什么方法，所以没法依靠反射获取方法来完成动作
     *  那么就用到了jdk自带的动态代理
     */
    @Override
    public void login() {
        user.login();
        logger.info("日志代理登录记录");
    }
}
